<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
	import="org.json.simple.JSONObject"
	import="org.json.simple.parser.JSONParser"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	String flowCellIdList = request.getParameter("flowcellidlist");
	String numLanesStringList = request.getParameter("numlaneslist");
	// Count number of id values
	int nFlowCells = 0;
	for (String s: flowCellIdList.split(","))
	{
		nFlowCells++;
	}
	// Get list of number of lanes per flow cell
	List<Integer> numLanesList = new ArrayList<Integer>();
	for (String s: numLanesStringList.split(","))
	{
		int numLanes = Integer.parseInt(s);
		numLanesList.add(numLanes);
	}
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title id="pageTitle">Lab protocol for clustering and sequencing</title>
	<link rel="SHORTCUT ICON" href="<%=home%>/images/flowcell.png">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/reggie.css">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/printable.css">
	<script language="JavaScript" src="<%=root%>/include/scripts/main.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=root%>/include/scripts/main-2.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=root%>/include/scripts/ajax.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=home %>/reggie.js" type="text/javascript" charset="UTF-8"></script>
	
	<script language="JavaScript">
	var debug = 0;
	var currentStep = 1;
	
	var COLORS = ['blue', 'green', 'yellow', 'red'];
	var nextColor = 0;
	
	function init()
	{
		var frm = document.forms['reggie'];
		var flowCellIdList = frm.fcIdList.value;
		// Load info on selected flow cells
		var flowCellInfo = getFlowCellInfo(flowCellIdList);
		viewAsList(flowCellInfo);
	}
	
	/**
	 * Returns a JSONArray with data for flow cells with database id values
	 * in input comma-separated string list.
	 *
	 * @param idList A comma-separated list of flow cell database id values.
	 * @return JSONArray with data for flow cells with input database id values.
	 */
	function getFlowCellInfo(idList)
	{
		var frm = document.forms['reggie'];	

		var request = Ajax.getXmlHttpRequest();
		try
		{
			showLoadingAnimation('Loading flow cell info...');
			var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=GetFlowCellInfo';
			url += '&idlist='+idList;
			request.open("GET", url, false);	
			request.send(null);
		}
		finally
		{
			hideLoadingAnimation();
		}
	
		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		return response.flowCellInfo;
	}

	function viewAsList(flowCellInfoArray)
	{
		var flowCellNo = -1;
		var flowCellNameList = '';
		var allColors = [];
		var useDarker = false;
		for (var index in flowCellInfoArray)
		{
			var poolColors = [];
			var poolsRow = document.getElementById('all-pools-'+index);
			flowCellNo++;
			var flowCell = flowCellInfoArray[index];
			var flowCellName = flowCell['name'];
			if (flowCellNo > 0)
			{
				flowCellNameList += ',';
			}
			flowCellNameList += flowCellName;
			setInnerHTML('flowCellName.'+flowCellNo, flowCellName);			
			setInnerHTML('flowCellDescription.'+flowCellNo, flowCell.description || '<i style="color: #999999;">Clustering comments</i>');				
			setInnerHTML('sequencingCycles.'+flowCellNo, flowCell.SequencingCycles);
			setInnerHTML('flowCellId.'+flowCellNo, flowCell.externalId);
			setInnerHTML('flowCellType.'+flowCellNo, flowCell.FlowCellType || '');
			if (flowCell.FlowCellType == 'NextSeq') Main.hide('pos.b.'+flowCellNo);
			var flowCellLanes = flowCell['lanes'];
			for (laneKey in flowCellLanes)
			{
				var poolName = flowCellLanes[laneKey];
				var color = poolColors[poolName];
				if (!color)
				{
					color = allColors[poolName];
					if (!color)
					{
						color = COLORS[nextColor] + (useDarker ? ' darker' : '');
						allColors[poolName] = color;
						nextColor++;
						if (nextColor == COLORS.length)
						{
							nextColor = 0;
							useDarker = !useDarker;
						}
					}
					poolColors[poolName] = color;
					var td = document.createElement('td');
					td.className = 'pool-legend ' + color;
					td.innerHTML = poolName;
					poolsRow.appendChild(td);
				}
				var row = laneKey - 1;
				var idSuffix = flowCellNo + '.' + row;
				Main.addClass(document.getElementById('fcPoolName.'+idSuffix), color);
				setInnerHTML('fcPoolName.'+idSuffix, poolName);				
			}
			
			if (poolColors.length <= 6)
			{
				// White-space at end to avoid pools getting to wide
				var td = document.createElement('td');
				td.innerHTML = '';
				poolsRow.appendChild(td);
			}
		}

		
		var pageTitle = 'Lab protocol for ' + flowCellNameList;
		setInnerHTML('pageTitle', pageTitle);				
		Main.show('listviewcontainer');
	}
	
	</script>
	<style>
	
	h1
	{
		margin-top: 1em;
	}
	
	h2
	{
		margin-bottom: 0;
		font-size: 1.2em;
	}
	
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}
	
	table.flowcell
	{
		min-height: 22em;
		height: 22em;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: middle;
		height: 2.5em;
		max-height: 2.5em;
		border-bottom: 1px solid #000000;
		border-top: 1px solid #000000;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 4px;
		border-right: 1px solid #000000;
	}

	table.protocolheader > tbody > tr > th.subprompt
	{
		text-align: right;
		font-weight: normal;
	}

	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 4px;
	}
	
	.colorbox 
	{
		display: inline-block;
		width: 0.75em; 
		height: 0.75em; 
		border: 1px solid #000000;
		margin-left: 0em;
		margin-right: 0.5em;
	}
	
	.pools
	{
		width: 100%;
		border-collapse: collapse;
	}
	
	.pools tr
	{
		height: 2.5em;
		border-bottom: 1px dotted #666666;
	}

	.pools tr:last-child
	{
		border-bottom: 0;
	}
	
	.pools td, .pools th
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}
	
	.pools th
	{
		background-color: #F0F0F0;
		border-bottom: 1px solid #000000;
	}
	
	.pools .lane-no
	{
		width: 5em;
		text-align: center;
	}
	
	.pools .pool-name
	{
		width: 8em;
		text-align: center;
	}
	
	.pool-legend
	{
		width: 8em;
		text-align: center !important;
	}
	
	.green
	{
		background-color: #D8F8D8;
	}
	.green.darker
	{
		background-color: #A0F8A0;
	}
	
	.blue
	{
		background-color: #D8E8FF;
	}
	.blue.darker
	{
		background-color: #B8B8FF;
	}
	
	.yellow
	{
		background-color: #FFFFD8;
	}
	.yellow.darker
	{
		background-color: #FFFFA0;
	}
	
	.red
	{
		background-color: #FFC8C8;
	}
	.red.darker
	{
		background-color: #F8A0A0;
	}

	
	</style>
</head>
<body onload="init()">
	<div class="paper">
	<form name="reggie" action="flowcell_protocol2.jsp" method="post" target="_blank">
	<div class="noprint fullwidth" style="border-bottom: 1px dashed #A0A0A0; padding-left: 1em; padding-bottom: 1em;">
		<span class="button" onclick="window.print()" style="float: left; margin-right: 1em;">
			<img src="../images/print.png">Print&hellip;
		</span>
		<b>Note!</b> 
		For better printing reduce margins to about <i>5mm</i> and set page orientation
		to <i>portrait</i>.
		<br clear="all">
	</div>
	
	<input type="hidden" name="fcIdList" value="<%=flowCellIdList%>">

	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	<div class="messagecontainer error" id="errorMessage" style="display: none;"></div>
	<div id="listviewcontainer" style="display: none;">
	
	<%
	// Note: Variable 'c' here indicates a flow cell, not a table column
	// Each flow cell is shown in its own table
	for (int c = 0; c < nFlowCells; ++c)
	{
		%>
		<h1>Lab protocol for clustering and sequencing <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

		<table class="protocolheader">
		<tr id="all-pools-<%=c%>">
			<th style="width: 15%;">Used pools</th>
		</tr>
		</table>
		
		<h2>1. Clustering</h2>
		<table style="width: 100%;" class="protocolheader flowcell">
		<tr style="">
			<th style="width: 15%;">Flow cell</th>
			<td style="width: 35%;"><div id="flowCellName.<%=c%>" >Flow cell name <%=c%></div></td>
			<td style="width: 50%; padding: 0; vertical-align: top; border-left: 1px solid #000000;" rowspan="7">
				<table class="pools">
				<tr>
					<th class="lane-no">Lane</th>
					<th class="pool-name">Pool name</th>
					<th class="remarks">Remarks</th>
				</tr>
				<tbody>
				<%
				int rows = (Integer) numLanesList.get(c);
				for (int r = 0; r < rows; ++r)
				{
					String idSuffix = c + "." + r;
					%>
					<tr id="row.<%=idSuffix%>">
						<td class="lane-no"><%=r+1%></td>
						<td class="pool-name" id="fcPoolName.<%=idSuffix%>"></td>
						<td class="remarks" id="fcPoolRemarks.<%=idSuffix%>"></td>
					</tr>
					<%
				}
				%>
				</tbody>
				</table>
			</td>
		</tr>
		<tr>
			<th>Flow cell type</th>
			<td id="flowCellType.<%=c%>"></td>
		</tr>
		<tr>
			<th>Flow cell ID</th>
			<td id="flowCellId.<%=c%>"></td>
		</tr>
		<tr>
			<th>Date</th>
			<td></td>
		</tr>
		<tr>
			<th>Operator</th>
			<td></td>
		</tr>
		<tr>
			<th>Cluster gen.</th>
			<td></td>
		</tr>
		
		<tr style="max-height: 100%; height: auto; vertical-align: top;">
			<td colspan="2" id="flowCellDescription.<%=c%>">Clustering comments</td>
		</tr>
		</table>
		
		
		<h2>2. Sequencing</h2>
			
		<table class="protocolheader">
		<tr>
			<th style="width: 25%;">Start date</th>
			<td style="width: 75%;" colspan="2"></td>
		</tr>
		<tr>
			<th>Operator</th>
			<td colspan="2"></td>
		</tr>

		<tr>
			<th>Sequencing machine</th>
			<td colspan="2"></td>
		</tr>

		<tr>
			<th>Sequencer position</th>
			<td colspan="2"><b><div class="colorbox"></div>A <span id="pos.b.<%=c%>"><div class="colorbox" style="margin-left: 2em;"></div>B</b></span></td>
		</tr>

		<tr>
			<th>Sequencing cycles</th>
			<td id="sequencingCycles.<%=c%>" style="width: 30%;"></td>
			<th>(Read 1 - Index - Read 2)</th>
		</tr>
		
		<tr>
			<th>First base report</th>
			<td colspan="2"><b><div class="colorbox"></div>Ok <div class="colorbox" style="margin-left: 2em;"></div>Not ok</b></td>
		</tr>

		<tr>
			<th style="width: 25%;">Turn-around date+time</th>
			<td style="width: 75%;" colspan="2"></td>
		</tr>

		<tr>
			<th style="width: 25%;">End date+time</th>
			<td style="width: 75%;" colspan="2"></td>
		</tr>

		<tr style="height: 10em; vertical-align: top;">
			<th>Comments</th>
			<td colspan="2"></td>
		</tr>
		</table>
		<div class="pagebreak"></div>
		<%
	}
	%>
	
	</div>
	</form>
	</div>
</body>
</html>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>