<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~persinfo.js" 
	styles="path.css,~../css/reggie-2.css" 
/>
<base:body>

	<p:path><p:pathelement
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Personal information registration" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">
	
	<!-- 1. Case + Personal number -->
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Enter Case Name and Personal Number</div>
		<div class="step-content">
		
			<table class="step-form">
			<tr>
				<td class="prompt">Case name</td>
				<td class="input">
					<input type="text" name="caseName" id="caseName"
						class="required auto-init" data-auto-init="focus" data-next-focus="personalNumber"
						style="width: 12em;" maxlength="12">
				</td>
				<td class="status" id="caseName.status"></td>
				<td class="help">
					<span id="caseName.message" class="message"></span>
					The case (barcode) associated with this patient.
				</td>
			</tr>
			<tr>
				<td class="prompt">Personal number</td>
				<td class="input">
					<input type="text" name="personalNumber" id="personalNumber"
						class="required"
						style="width: 12em;" maxlength="12">
				</td>
				<td class="status" id="personalNumber.status"></td>
				<td class="help">
					<span id="personalNumber.message" class="message"></span>
					([YY]YYMMDDZZZZ)
				</td>
			</tr>
			</table>
		</div>
	</div>

	<!-- 2. New patient registration -->
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title" id="step-2-title">New patient: Enter all names</div>
		<div class="step-content">
			
			<table class="step-form">
			<tr>
				<td class="prompt">Patient code</td>
				<td class="input"><input type="text" name="patientCode" id="patientCode"
					class="auto-init" data-auto-init="focus-on-enter" data-next-focus="familyName"
					style="width: 12em;" maxlength="12"></td>
				<td class="status" id="patientCode.status"></td>
				<td class="help">
					<span id="patientCode.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="prompt">Family name</td>
				<td class="input"><input type="text" name="familyName" id="familyName"
					class="auto-init" data-auto-init="focus-on-enter" data-next-focus="allFirstNames"
					style="width: 20em;" maxlength="255"></td>
				<td class="status" id="familyName.status"></td>
				<td class="help">
					<span id="familyName.message" class="message"></span>
					Keep hyphens, keep åäö, replace all special accented letters [e.g. éèü etc] with standard alphabet character.
				</td>
			</tr>
			<tr>
				<td class="prompt">All first names</td>
				<td class="input"><input type="text" name="allFirstNames" id="allFirstNames"
					style="width: 20em;" maxlength="255"></td>
				<td class="status" id="allFirstNames.status"></td>
				<td class="help">
					<span id="allFirstNames.message" class="message"></span>
					Type all names, see FamilyName comment on valid characters.
				</td>
			</tr>
			<tr>
				<td class="prompt">Gender</td>
				<td class="input" id="gender"></td>
				<td class="status" id="gender.status" rowspan="2"></td>
				<td class="help" rowspan="2">
					<span id="gender.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="prompt">Date of birth</td>
				<td class="input" id="dateOfBirth"></td>
			</tr>
			</table>
			
		</div>
	</div>


	<!-- 3. Case registration -->
	<div class="step" id="step-3">
		<div class="step-no">3</div>
		<div class="step-title" id="step-3-title">Register new case</div>
		<div class="step-content">
		
			<table class="step-form">
			<tr>
				<td class="prompt" id="laterality.prompt">Laterality</td>
				<td class="input" id="laterality.input">
					<label><input type="radio" name="laterality" value="LEFT" id="lateralityLeft">LEFT</label><br>
					<label><input type="radio" name="laterality" value="RIGHT" id="lateralityRight">RIGHT</label><br>
					<label><input type="radio" name="laterality" value="" checked id="lateralityUnknown"><i>unknown</label></i>
				</td>
				<td class="status" id="laterality.status"></td>
				<td class="help">
					<span id="laterality.message" class="message"></span>
				</td>
			</tr>
			<tr id="copyConsentSection" style="display: none;">
				<td class="prompt">Copy consent?</td>
				<td class="input">
					<input type="checkbox" name="copyConsent" id="copyConsent" value="" checked>
					<label for="copyConsent"><span id="copyConsent.text"></span></label>
				</td>
				<td class="status" id="copyConsent.status"></td>
				<td class="help"></td>
			</tr>
			<tr id="padSection">
				<td class="prompt">PAD</td>
				<td class="input">
					<input type="text" name="pad" id="pad"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="samplingDate"
						style="width: 18em;" maxlength="12">
				</td>
				<td class="status" id="pad.status"></td>
				<td class="help">
					<span id="pad.message" class="message"></span>
				</td>
			</tr>
			<tr id="coreBiopsiesSection" style="display: none;">
				<td class="prompt">Core biopsies</td>
				<td class="input" id="coreBiopsies"><i>not found</i></td>
				<td class="status" id="coreBiopsies.status"></td>
				<td class="help">
					The listed core biopsies are already registered with this case. 
					They are not affected by this update unless the laterality is changed.
				</td>
			</tr>
			<tr>
				<td class="prompt">Specimen tubes</td>
				<td class="input" id="specimenTubes"><i>not found</i></td>
				<td class="status" id="specimenTubes.status"></td>
				<td class="help">
					<span id="specimenTubes.message" class="message"></span>
					The specimen tube(s) associated with this case.
				</td>
			</tr>
			<tr id="samplingDateSection">
				<td class="subprompt">Sampling date</td>
				<td class="input">
					<input type="text" name="samplingDate" id="samplingDate"
						style="width: 12em;" maxlength="10">
					<span id="samplingTimeField">Time <input type="text" name="samplingTime" id="samplingTime"
						style="width: 6em;" maxlength="5"></span>
				</td>
				<td class="status" id="samplingDate.status"></td>
				<td class="help">
					<span id="samplingDate.message" class="message"></span>
					Date (+time) of surgical removal (YYYYMMDD, HHMM)
				</td>
			</tr>
			<tr id="rnaLaterDateSection">
				<td class="subprompt">RNA Later date</td>
				<td class="input">
					<input type="text" name="rnaLaterDate" id="rnaLaterDate"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="rnaLaterTime"
						style="width: 12em;" maxlength="10">
					Time <input type="text" name="rnaLaterTime" id="rnaLaterTime"
						style="width: 6em;" maxlength="5">
					</td>
				<td class="status" id="rnaLaterDate.status"></td>
				<td class="help">
					<span id="rnaLaterDate.message" class="message"></span>
					Date+time of pathology handling (YYYYMMDD, HHMM)
				</td>
			</tr>
			<tr id="reasonIfNoSpecimenSection" class="align-top">
				<td class="subprompt">Reason if no specimen</td>
				<td class="input">
					<textarea name="reasonIfNoSpecimen" id="reasonIfNoSpecimen"
						rows="3" style="width: 100%;"
					></textarea>
				</td>
				<td class="status"></td>
				<td class="help">Comment why there was no specimen tubes in the delivery.</td>
			</tr>
			</table>
		</div>
	</div>

	<div id="wizard-status"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goupdate" title="Update" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
		
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>