<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String lysateName = request.getParameter("lysate");
	final int index = Values.getInt(request.getParameter("index"));
	final String title = "Edit Qiacube/DNA/RNA/FT details for " + lysateName;
%>
<base:page type="popup" title="<%=title %>">
<base:head >

<script>
function init()
{
	var lysate = window.opener.selectedLysates[<%=index%>];
	var frm = document.forms['details'];

	frm.qiacubePosition.value = lysate.qiacubePosition;
	frm.lysateOriginalQuantity.value = lysate.originalQuantity;
	frm.lysateUsedQuantity.value = lysate.processedQuantity;

	frm.dnaVolume.value = lysate.dna.volume;
	frm.rnaVolume.value = lysate.rna.volume;
	frm.ftVolume.value = lysate.ft.volume;
	
	frm.lysateComment.value = lysate.comment || '';
	frm.dnaComment.value = lysate.dna.comment || '';
	frm.rnaComment.value = lysate.rna.comment || '';
	frm.ftComment.value = lysate.ft.comment || '';
	
	checkForm();
	frm.qiacubePosition.focus();
}

var formIsValid = false;

function saveDetails()
{
	if (!formIsValid) return;
	
	var lysate = window.opener.selectedLysates[<%=index%>];
	var frm = document.forms['details'];

	lysate.qiacubePosition = parseInt(frm.qiacubePosition.value, 10);
	lysate.originalQuantity = parseFloat(frm.lysateOriginalQuantity.value);
	lysate.processedQuantity = parseFloat(frm.lysateUsedQuantity.value);
	lysate.comment = frm.lysateComment.value;

	lysate.dna.volume = parseFloat(frm.dnaVolume.value);
	lysate.dna.comment = frm.dnaComment.value;
	lysate.rna.volume = parseFloat(frm.rnaVolume.value);
	lysate.rna.comment = frm.rnaComment.value;
	lysate.ft.volume = parseFloat(frm.ftVolume.value);
	lysate.ft.comment = frm.ftComment.value;
	
	window.opener.updateDetailsTable();
	window.close();
}

function checkForm()
{
	formIsValid = false;
	var frm = document.forms['details'];
	
	// Qiacube position
	var qiacubePosition = parseInt(frm.qiacubePosition.value, 10);
	if (!(qiacubePosition > 0) || !(qiacubePosition <= 12))
	{
		showError('Qiacube position must be between 1 and 12.');
		return;
	}
	
	// Lysate quanities
	var lysateOriginalQuantity = parseFloat(frm.lysateOriginalQuantity.value);
	if (!(lysateOriginalQuantity > 0))
	{
		showError('Invalid value for Lysate total quantity.');
		return;
	}
	var lysateUsedQuantity = parseFloat(frm.lysateUsedQuantity.value);
	if (!(lysateUsedQuantity > 0))
	{
		showError('Invalid value for Lysate used quantity.');
		return;
	}
	if (lysateUsedQuantity > lysateOriginalQuantity)
	{
		showError('Lysate used quantity is bigger than total quantity.');
		return;
	}

	// DNA
	var dnaVolume = parseFloat(frm.dnaVolume.value);
	if (!(dnaVolume > 0))
	{
		showError('Invalid value for DNA volume.');
		return;
	}

	// RNA
	var rnaVolume = parseFloat(frm.rnaVolume.value);
	if (!(rnaVolume > 0))
	{
		showError('Invalid value for RNA volume.');
		return;
	}
	
	// FT
	var ftVolume = parseFloat(frm.ftVolume.value);
	if (!(ftVolume > 0))
	{
		showError('Invalid value for FT volume.');
		return;
	}

	Main.hide('error');
	formIsValid = true;
}

function showError(msg)
{
	document.getElementById('error').innerHTML = msg;
	Main.show('error');
}

</script>

</base:head>
<base:body onload="init()">
	<h1><%=title %></h1>

	<form name="details">

	<div class="content bottomborder">
	
		<table class="fullform input100">
		<tr>
			<th>Qiacube position</th>
			<td>
				<input type="text" name="qiacubePosition" 
					style="width: 5em;"	maxlength="3" 
					onkeypress="return Numbers.integerOnly(event)"
					onblur="checkForm()"
					> (1--12)
			</td>
		</tr>
		<tr>
			<th>Lysate total quantity</th>
			<td>
				<input type="text" name="lysateOriginalQuantity" 
					style="width: 10em;" maxlength="8"
					onkeypress="return Numbers.numberOnly(event)"
					onblur="checkForm()"
					> (µl)
			</td>
		</tr>
		<tr>
			<th class="subprompt">used quantity</th>
			<td>
				<input type="text" name="lysateUsedQuantity" 
					style="width: 10em;" maxlength="8"
					onkeypress="return Numbers.numberOnly(event)"
					onblur="checkForm()"
					> (µl)
			</td>
		</tr>
		<tr>
			<th class="subprompt">comment</th>
			<td>
				<input type="text" name="lysateComment" maxlength="255">
			</td>
		</tr>
		<tr>
			<th>DNA volume</th>
			<td>
				<input type="text" name="dnaVolume" 
					style="width: 10em;" maxlength="8"
					onkeypress="return Numbers.numberOnly(event)"
					onblur="checkForm()"
					> (µl)
			</td>
		</tr>
		<tr>
			<th class="subprompt">comment</th>
			<td>
				<input type="text" name="dnaComment" maxlength="255">
			</td>
		</tr>
		<tr>
			<th>RNA volume</th>
			<td>
				<input type="text" name="rnaVolume" 
					style="width: 10em;" maxlength="8"
					onkeypress="return Numbers.numberOnly(event)"
					onblur="checkForm()"
					> (µl)
			</td>
		</tr>
		<tr>
			<th class="subprompt">comment</th>
			<td>
				<input type="text" name="rnaComment" maxlength="255">
			</td>
		</tr>
		<tr>
			<th>FT volume</th>
			<td>
				<input type="text" name="ftVolume" 
					style="width: 10em;" maxlength="8"
					onkeypress="return Numbers.numberOnly(event)"
					onblur="checkForm()"
					> (µl)
			</td>
		</tr>
		<tr>
			<th class="subprompt">comment</th>
			<td>
				<input type="text" name="ftComment" maxlength="255">
			</td>
		</tr>
		<tr class="dynamic">
			<th></th>
			<td>
				<div id="error" class="messagecontainer error" style="display: none;">
				</div>
			</td>
		</tr>
		</table>
	
	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons" id="dialogbuttons">
		<base:button onclick="saveDetails()" title="Ok" />
		<base:button onclick="window.close()" title="Cancel" />
	</base:buttongroup>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>